#!/bin/sh
#
# SuperDuper DiskUtil Repair & Email Log
#
# Revised - Mon, May 4, 2007
# 
# This script repairs a volume syncronized with SuperDuper & emails the log file
#
# Copyright (c) 2007 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.

##################################
# Global Editable Variables

PATH_OF_VOLUME_TO_REPAIR="/Volumes/MyVolume"
PATH_TO_SUPERDUPER_LOGS='/Users/[username]/Library/Application Support/SuperDuper!/Saved Settings/[name of settings].sdsp/Logs'
PATH_TO_SYSTEMSETUP="/System/Library/CoreServices/RemoteManagement/ARDAgent.app/Contents/Support/systemsetup"
PATH_TO_LOG_FILE="/var/log/superduper.log"
MAIL_TO='myname@mydomain.edu'

#////////////////////////////////////////////////////////////////////////////////////////
#////////////////////////////////////////////////////////////////////////////////////////

mail_log()
{

# email subject
EMAIL_SUBJECT="${COMPUTER_NAME} - SupderDuper Sync $(date)"

# Email text/message
EMAIL_MESSAGE="${PATH_TO_LOG_FILE}"

# send an email using /bin/mail
mail -s "${EMAIL_SUBJECT}" "${MAIL_TO}" < "${EMAIL_MESSAGE}"
	
}


#////////////////////////////////////////////////////////////////////////////////////////
#////////////////////////////////////////////////////////////////////////////////////////

diskutil_repair()
{

echo >> "${PATH_TO_LOG_FILE}"
echo "   RUNNING DISK UTILITY:				$(date)" >> "${PATH_TO_LOG_FILE}"
echo "****************************************************************************************" >> "${PATH_TO_LOG_FILE}"
echo >> "${PATH_TO_LOG_FILE}"

diskutil repairVolume "${PATH_OF_VOLUME_TO_REPAIR}" 2>&1 >> "${PATH_TO_LOG_FILE}"
	
}


#////////////////////////////////////////////////////////////////////////////////////////
#////////////////////////////////////////////////////////////////////////////////////////

superduper_log()
{

echo >> "${PATH_TO_LOG_FILE}"
echo "   SUPERDUPER LOG:				$(date)" >> "${PATH_TO_LOG_FILE}"
echo "****************************************************************************************" >> "${PATH_TO_LOG_FILE}"
echo >> "${PATH_TO_LOG_FILE}"

textutil -cat txt -stdout "$(find "$PATH_TO_SUPERDUPER_LOGS" -type f -mmin -5 -name "*.sdlog" -print)" >> "${PATH_TO_LOG_FILE}"
	
}


#////////////////////////////////////////////////////////////////////////////////////////
#////////////////////////////////////////////////////////////////////////////////////////

quit_superduper()
{

osascript <<EOT
tell application "SuperDuper!"
	quit without saving
end tell
EOT
	
}


#////////////////////////////////////////////////////////////////////////////////////////
#////////////////////////////////////////////////////////////////////////////////////////

##################################
# Main Script

# Get computer name
COMPUTER_NAME="$(${PATH_TO_SYSTEMSETUP} -getcomputername | sed 's/Computer Name: ''//g')"

echo "   SUPERDUPER SYNC				$(date)"  > "${PATH_TO_LOG_FILE}"
echo "****************************************************************************************" >> "${PATH_TO_LOG_FILE}"
echo "   Computer Name: ${COMPUTER_NAME}"  >> "${PATH_TO_LOG_FILE}"

diskutil_repair
superduper_log
mail_log
quit_superduper

exit 0;